#!/usr/bin/env python
#
# Problem EPage 411
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import pi 

M = 115
H = 0.8 
r = 0.25 
rho = 1.e3 # density of H20 (kg/m^3) 

from goldSearch import bracket, search

def f(x):
    Volume_of_H20 = pi * r**2 * x
    Mass_of_H20 = Volume_of_H20 * rho 
    return ( M * ( 0.43 * H ) + Mass_of_H20 * ( x / 2. ) ) / ( M + Mass_of_H20 ) 

xStart = 0.1
h = 0.01 
x1, x2 = bracket(f,xStart,h)
x, fMin = search(f,x1,x2)
print "x= ", x 
print "f(x)= ", fMin

if False:
    xs = np.linspace( 0.0, 0.4, 100 ) 
    fs = [ f(_) for _ in xs ]
    import pylab
    pylab.plot( xs, fs )
    pylab.xlabel('x')
    pylab.ylabel('f')
    pylab.grid('on')
    pylab.show()

    
