#!/usr/bin/env python
#
# Problem EPage 410 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, pi, sin, cos, zeros, ones 

from gaussElimin import gaussElimin
from powell import powell

def objective_fn(x):
    return 2 * x[0]**2 + 3 * x[1]**2 + x[2]**2 + x[0] * x[1] + x[0] * x[2] - 2 * x[1] 

A = ones( (3,3), dtype=float ) 
A[0,0] = 4
A[1,1] = 6
A[1,2] = 0
A[2,1] = 0
A[2,2] = 2 

b = zeros( (3,1), dtype=float )
b[1] = 2 
if False: 
    print "A= ", A
    print "b= ", b 
gaussElimin(A,b) 
print "analytic solution x= ", b.T

# Solve using a minimization routine:
# 
xStart = asarray( [0.5,1.0,2.0] )
x, numIter = powell( objective_fn, xStart, 0.01 ) 
print "Minimium point= ", x
print "Function value= ", objective_fn(x)

