#!/usr/bin/env python
#
# Problem EPage 410 
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, zeros, pi, log

# Constants of this problem:
# 
q = 50 
a = 5 * 1.e-3 # in meters 
k = 0.16 
h = 20 
T_infty = 280 

C = q / ( 2*pi ) 

from goldSearch import bracket, search

def f(r):
    """
    A function for minimization
    """
    return C * ( log(r/a)/k + 1./(h*r) ) + T_infty

xStart = 0.1
h = 0.01 
x1, x2 = bracket(f,xStart,h)
x, fMin = search(f,x1,x2)
print "x= ", x 
print "f(x)= ", fMin

if False: 
    xs = np.linspace( 10, 20, 200 ) 
    fs = [ f(_) for _ in xs ]
    import pylab
    pylab.plot( xs, fs )
    pylab.xlabel('r')
    pylab.ylabel('f')
    pylab.grid('on')
    pylab.show()


