#!/usr/bin/env python
#
# Problem EPage 106
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, identity, zeros, diag

from gaussSeidel import * 

def iterEqs(x,omega=1): 
    n = len(x)
    gs_update = ( b - ( dot(A,x) - diag(A) * x ) ) / diag(A) 
    return omega * gs_update + (1-omega) * x  

A = asarray( [ [ 12, -2, 3, 1 ], [ -2, 15, 6, -3 ], [ 1, 6, 20, -4 ], [ 0, -3, 2, 9 ] ], dtype=float ) 
b = asarray( [ 0, 0, 20, 0 ], dtype=float ) 

x = b/diag(A)
x,numIter,omega = gaussSeidel(iterEqs,x)
print "x= ", x 
print "numIter= ", numIter
print "omega= ", omega 
print np.linalg.norm(dot(A,x)-b) # Check our solution: 
