#!/usr/bin/env python
#
# Problem EPage 106
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, identity

from LUpivot import *

def matInv(a):
    n = a.shape[0]
    aInv = identity(n)
    a,seq = LUdecomp(a)
    for i in range(n):
        aInv[:,i] = LUsolve(a,aInv[:,i],seq)
    return aInv 

# Input the stiffness matrix K: 
K = asarray( [ [ 27.580, 7.004, -7.004, 0.000, 0.000 ], 
               [ 7.004, 29.570, -5.253, 0.000, -24.320 ], 
               [ -7.004, -5.253, 29.570, 0.000, 0.000 ], 
               [ 0.000, 0.000, 0.000, 27.580, -7.004 ], 
               [ 0.000, -24.320, 0.000, -7.004, 29.570 ] ], dtype=float )
K_orig = K.copy()
kInv = matInv(K)
print "kInv (flexibility matrix)= "
print kInv
print np.linalg.norm( ( dot(kInv,K_orig) - identity(K_orig.shape[0]) ).flatten() ) 

p = asarray( [ 0, 0, 0, 0, -45 ], dtype=float )
print "K^{-1} p= ", dot(kInv,p)
