#!/usr/bin/env python
#
# Problem EPage 106
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, dot, identity

from LUpivot import *

def matInv(a):
    n = a.shape[0]
    aInv = identity(n)
    a,seq = LUdecomp(a)
    for i in range(n):
        aInv[:,i] = LUsolve(a,aInv[:,i],seq)
    return aInv 

A = asarray( [ [ 3, -7, 45, 21 ], [ 12, 11, 10, 17 ], [ 6, 25, -80, -24 ], [ 17, 55, -9, 7 ] ], dtype=float )
A_orig = A.copy()
aInv = matInv(A)
print "aInv= "
print aInv
print np.linalg.norm( ( dot(aInv,A_orig) - identity(A_orig.shape[0]) ).flatten() ) 

B = asarray( [ [ 1, 1, 1, 1 ], [ 1, 2, 2, 2 ], [ 2, 3, 4, 4 ], [ 4, 5, 6, 7 ] ], dtype=float )
B_orig = B.copy()
bInv = matInv(B)
print "bInv= "
print bInv
print np.linalg.norm( ( dot(bInv,B_orig) - identity(B_orig.shape[0]) ).flatten() ) 
