#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, argsort
from neville import neville

# Our data:
# 
xData = asarray( [ -2.0, -0.1, -1.5, 0.5, -0.6, 2.2, 1.0, 1.8 ] )
yData = asarray( [ 2.2796, 1.0025, 1.6467, 1.0635, 1.0920, 2.6291, 1.2661, 1.9896 ] )

# Don't recall if these methods need the input array x sorted (but it can't hurt): 
#
asd = argsort(xData)
xData = xData[asd]
yData = yData[asd]

for x_interp in [ 1.1, 1.2, 1.3 ]:

    # Neville's interpolation:
    # 
    y_interp_neville = neville(xData,yData,x_interp)

    print "x= %10.6f; neville= %10.6f" % (x_interp,y_interp_neville)






