#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, pi
import newtonPoly
from neville import neville
import cubicSpline 

# Our data:
# 
xData = asarray( [ -250, -200, -100, 0, 100, 300 ] ) 
yData = asarray( [ 0.0163, 0.318, 0.699, 0.870, 0.941, 1.04 ] )

for x_interp in [ 200, 400 ]: 

    # Neville's interpolation:
    # 
    y_interp_neville = neville(xData,yData,x_interp)

    # Cubic spline interpolation:
    # 
    k = cubicSpline.curvatures(xData,yData)
    y_interp_spline = cubicSpline.evalSpline(xData,yData,k,x_interp) 
    
    print "T= %10.6f; neville= %10.6f, spline= %10.6f" % (x_interp,y_interp_neville,y_interp_spline)






