#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, pi, log, exp, argsort 
from neville import neville

n_neighbors = 4

# Our data:
# 
xData = log( asarray( [ 0.2, 2, 20, 200, 2000, 20000 ] ) )
yData = log( asarray( [ 103, 13.9, 2.72, 0.800, 0.401, 0.433 ] ) )

for x_interp in log( asarray( [ 5, 50, 500, 5000 ] ) ): 

    # Find the four nearest points:
    # 
    neighbors_argsort = argsort( abs( xData - x_interp ) )
    
    xData_tmp = []
    yData_tmp = []
    for ii in range(n_neighbors):
        inds = neighbors_argsort == ii 
        xData_tmp.append( xData[inds][0] )
        yData_tmp.append( yData[inds][0] )
    xData_tmp_argsort = argsort( xData_tmp )
    xData_tmp = asarray( xData_tmp )[xData_tmp_argsort] 
    yData_tmp = asarray( yData_tmp )[xData_tmp_argsort] 

    # Neville's interpolation:
    # 
    y_interp_neville = neville(xData_tmp,yData_tmp,x_interp)
    
    print "Re= %10.3f; NN Neville= %10.6f" % (exp(x_interp),exp(y_interp_neville))






