#!/usr/bin/env python
#
# Problem EPage 133
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import asarray, pi
from neville import neville
import cubicSpline 

# Our data:
# 
xData = asarray( [ 0, 21.1, 37.8, 54.4, 71.1, 87.8, 100 ] )
yData = asarray( [ 1.79, 1.13, 0.696, 0.519, 0.338, 0.321, 0.296 ] )

for x_interp in [ 10, 30, 60, 90 ]:

    # Neville's interpolation:
    # 
    y_interp_neville = neville(xData,yData,x_interp)

    # Cubic spline interpolation:
    # 
    k = cubicSpline.curvatures(xData,yData)
    y_interp_spline = cubicSpline.evalSpline(xData,yData,k,x_interp) 
    
    print "T= %10.6f; neville= %10.6f, spline= %10.6f" % (x_interp,y_interp_neville,y_interp_spline)






