#!/usr/bin/env python
#
# Problem EPage 178
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import empty, asarray, cos, sin, tan, pi
from newtonRaphson2 import *

g = 9.81 
 
def f(x): 
    v, theta, t = x # unknowns are ordered as such 
    f = empty( (len(x)) ) 
    y_dot = - g * t + v * sin(theta) 
    x_dot = v * cos(theta) 
    x_pos = x_dot * t 
    f[0] = tan( y_dot / x_dot ) + 1 
    f[1] = x_pos - 300 
    f[2] = -0.5 * g * t**2 + v * sin(theta) * t - 61
    return f 

if __name__ == "__main__":
    
    theta0 = pi/4 # split 90 degrees "in half"
    t0 = sqrt( (-2) * ( 61 - 300 ) / g )
    v0 = ( 300 / cos(theta0) ) / t0 
    
    x0 = [ v0, theta0, t0 ] # our initial values
    print "initial values of v,theta,t= ", x0
    xN = newtonRaphson2( f, asarray( x0 ) )
    print "final values of v,theta,t= ", xN
    


