#!/usr/bin/env python
#
# Problem EPage 221
# Example of this on EPage 216
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import exp, linspace, empty, isfinite, pi 
from romberg import romberg
from trapezoid import trapezoid

def int_part_g(x):
    if x==0 : 
        v = 0.
    else : 
        v = ( x**4 * exp(x) ) / ( ( exp(x) - 1 )**2 ) 
    return v 

def compute_integral_w_trapezoid(u,Nmax=20): 
    Iold = 0.
    for k in range(1,Nmax+1): 
        Inew = trapezoid(int_part_g,0.0,1./u,Iold,k)
        if (k>1) and (abs(Inew - Iold) < 1.e-6) : break 
        Iold = Inew
    return Inew 

N = 21
us = linspace( 0, 1, N )
g_of_u = empty( N )
g_of_u[0] = 0. # do the case u=0 separatly
for ui,u in enumerate(us): 
    if u==0 : continue # already done 

    # Evaluate the integral numerically:
    # 
    if True : 
        romb = romberg(int_part_g,0,1./u)
        u_int = romb[0]
    else :
        u_int = compute_integral_w_trapezoid(u)

    g_of_u[ui] = u**3 * u_int

print us
print g_of_u
