#!/usr/bin/env python
#
# Problem EPage 224
# Example of this on EPage 216
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import exp, sin, log
from romberg import romberg
from trapezoid import trapezoid

i0 = 100
t0 = 0.01
R = 0.5

eps_precision = ( 1.e-6 / R ) 
T = -(t0/2) * log( 2 * eps_precision / ( i0**2 * t0 ) )
print "T= ", T 

def f(t): return R * ( i0 * exp(-t/t0) * sin(2*t/t0) )**2 

print "Our integral estimated using the recursive trapezoid rule..."
Iold = 0.
for k in range(1,21): 
    Inew = trapezoid(f,0.0,T,Iold,k)
    if (k>1) and (abs(Inew - Iold) < eps_precision) : break 
    Iold = Inew

print "Integral= ", Inew
print "nPanels= ", 2**(k-1)

print "Our integral estimated using romberg..."
u_int = romberg(f,0,T)
print u_int
