#!/usr/bin/env python
#
# Problem EPage 221
# Example of this on EPage 216
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
from numpy import zeros, pi

#      0       1     2       3    4
xs = [ 0,   pi/4, pi/2, 3*pi/4,  pi ]
ys = [ 1, 0.3431, 0.25, 0.3431, 1.0 ]

# Construct R_{i,1} i.e. the trapezoidal approximations of our intergral with 2^{i-1} panels:
# 

# 1 panel
R_1_1 = 0.5 * ( xs[4] - xs[0] ) * ( ys[4] + ys[0] ) 

# 2 panels 
R_2_1 = 0.5 * ( xs[4] - xs[2] ) * ( ys[4] + ys[2] ) + 0.5 * ( xs[2] - xs[0] ) * ( ys[2] + ys[0] ) 

# 4 panels
R_3_1 = 0.
for ii in range(1,4+1):
    R_3_1 = R_3_1 + 0.5 * ( xs[ii] - xs[ii-1] ) * ( ys[ii-1] + ys[ii] ) 

# Fill the first column of the R matrix: 
R = zeros( (3,3) )
R[0,0] = R_1_1
R[1,0] = R_2_1 
R[2,0] = R_3_1

# Perform Richards extrapolation (Formuls 6.13a modified for 0 based indexing) in each column of R: 
#
for jj in range(1,3): # for each column 
    const = 4.0**jj
    for ii in range(jj,3): # for each row 
        R[ii,jj] = ( const * R[ii,jj-1] - R[ii-1,jj-1] ) / ( const - 1. )
print R 
