#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sqrt, sin, cos, asarray, zeros, interp, pi 
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

m = 0.25
C_D = 0.03 
g = 9.80665

def F(t,y): 
    F = zeros( (4,), dtype=float ) # vector y is = [ x(t), x'(t), y(t), y'(t) ] 
    v = sqrt( y[1]**2 + y[3]**2 )
    F[0] = y[1]
    F[1] = -(C_D/m) * y[1] * sqrt(v) 
    F[2] = y[3]
    F[3] = -(C_D/m) * y[3] * sqrt(v) - g 
    return F

t0 = 0.0 # start of the integration 
tStop = 4.0 # end of the integration 
theta0 = 30 * ( pi / 180. ) 
v0 = 50
y0 = asarray( [ 0, v0*cos(theta0), 0, v0*sin(theta0) ], dtype=float ) 
h = 0.01
freq = 20

T,Y = integrate(F,t0,y0,tStop,h) 
#printSoln(T,Y,freq)

if False: 
    if False: 
        pylab.plot( T, Y[:,2] )
        pylab.xlabel('t (time)'); pylab.ylabel('y(t)')
    else: 
        pylab.plot( Y[:,0], Y[:,2] )
        pylab.xlabel('x(t)'); pylab.ylabel('y(t)'); pylab.title('the projectiles path')
    pylab.grid('on')
    pylab.show() 

# The time of flight is the time when y(t)=0 
#
t_inds = T > 3.0 # visually, the time of flight is at least this large
t_small = T[t_inds] # extract data around this time 
y_small = Y[t_inds,2]
y_sort_index = np.argsort( y_small )
y_sorted = y_small[y_sort_index]
t_sorted = t_small[y_sort_index]
time_of_flight = interp( 0, y_sorted, t_sorted )
print "Time when y=0 is= ", time_of_flight

# The range is the x(t) value when y(t) = 0
#
t_inds = T > 3.0 # visually, the time of flight is at least this large
t_small = T[t_inds] # extract data around this time 
x_small = Y[t_inds,0]
y_small = Y[t_inds,2]
y_sort_index = np.argsort( y_small )
y_sorted = y_small[y_sort_index]
x_sorted = x_small[y_sort_index]
projectile_range = interp( 0, y_sorted, x_sorted )
print "Projectile range= ", projectile_range
