#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sqrt, sin, cos, asarray, zeros, interp, pi 
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

a = 100.
b = 15.

def F(t,y): 
    F = zeros( (2,), dtype=float ) # vector y is = [ theta(t), theta'(t) ]
    F[0] = y[1]
    F[1] = ( a*(b-y[0]) - y[0] * y[1]**2 ) / ( 1 + y[0]**2 ) 
    return F

t0 = 0.0 # start of the integration 
tStop = 0.5 # end of the integration 
y0 = asarray( [ 2*pi, 0. ], dtype=float ) 
h = 0.01
freq = 0

T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

if False:
    pylab.plot( T, Y[:,0] )
    pylab.xlabel('t (time)'); pylab.ylabel('theta(t)')
    pylab.grid('on')
    pylab.show() 
