#!/usr/bin/env python
#
# Problem EPage 275
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from taylor import taylor 
from printSoln import printSoln
import pylab 

def deriv(x,y): 
    D = zeros( (4,1), dtype=float )  
    # vector y is = [ y(t) ]
    D[0] = sin(y[0])                                                # the first derivative 
    D[1] = cos(y[0]) * sin(y[0])                                    # the second deriative 
    D[2] = -sin(y[0])**3 + cos(y[0])**2 * sin(y[0])                 # the third deriative
    D[3] = -5 * sin(y[0])**3 * cos(y[0]) + cos(y[0])**3 * sin(y[0]) # the fourth derivative 
    return D

x0 = 0.0 # start of the integration 
xStop = 0.5 # end of the integration 
freq = 0

y0 = asarray( [ 1 ], dtype=float ) 
h = 0.1 
X,Y = taylor(deriv,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if False: 
    pylab.plot( X, Y[:,0], color='black', label='approx. sol.' )
    pylab.hold('on')
    pylab.xlabel('x'); pylab.ylabel('y(x)')
    pylab.grid('on')
    pylab.legend()
    pylab.show() 
