#!/usr/bin/env python
#
# Problem EPage 275
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
if True: 
    from run_kut4 import integrate
else: 
    from run_kut5 import integrate
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t) ]
    F = zeros( (1,), dtype=float ) 
    F[0] = y[0]**(1./3) 
    return F 

x0 = 0.0 # start of the integration 
xStop = 5.0 # end of the integration 
freq = 0

print "Part (a): y(0) = 0"
y0 = asarray( [ 0. ], dtype=float ) 
h = 0.01 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

print "Part (b): y(0) = 10^(-16)"
y0 = asarray( [ 1.e-16 ], dtype=float ) 
h = 1.e-3
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

Y_truth = ( (2./3) * X )**(3./2)
print h, np.linalg.norm( Y_truth - Y[:,0] )

if False: 
    pylab.plot( X, Y[:,0], color='black', label='approx. sol.' )
    pylab.hold('on')
    pylab.plot( X, Y_truth, color='green', label='true sol.' )
    pylab.xlabel('x'); pylab.ylabel('y(x)')
    pylab.grid('on')
    pylab.legend()
    pylab.show() 
