#!/usr/bin/env python
#
# Problem EPage 276
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import sin, asarray, zeros, interp
from run_kut4 import integrate
from printSoln import printSoln
import pylab 

g = 9.80665
c_D = 0.2028
m = 80 

def F(x,y): 
    F = zeros( (2,), dtype=float ) 
    F[0] = y[1]
    F[1] = - ( g - (c_D/m) * y[1]**2 )
    return F

x0 = 0.0 # start of the integration 
xStop = 14.0 # end of the integration 
y0 = asarray( [ 500., 0. ], dtype=float ) 
h = 0.1 
freq = 20

X,Y = integrate(F,x0,y0,xStop,h) 
#printSoln(X,Y,freq)

if True:
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('time (t)'); pylab.ylabel('y(t)');
    pylab.axhline(y=0,color='green')
    pylab.grid('on')
    pylab.show() 

# Find the time at which y(t) crosses zero:
# 
y_sort_inds = np.argsort( Y[:,0] ) 
y_sorted = Y[y_sort_inds,0]
x_sorted = X[y_sort_inds]
print "Time when y=0 is= ", interp( 0, y_sorted, x_sorted ) 
