#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros
from bulStoer import bulStoer
from printSoln import printSoln
import pylab 

def F(x,y): 
    # vector y is = [ y(t), y'(t) ] 
    F = zeros( (len(y),), dtype=float ) 
    F[0] = y[1] 
    F[1] = ( -y[0] - x * y[1] ) / x**2 
    return F 

x0 = 1.0 # start of the integration 
xStop = 20.0 # end of the integration 
H = 0.5
freq = 0 

y0 = asarray( [ 0, -2 ], dtype=float ) 
X,Y = bulStoer(F,x0,y0,xStop,H) 
printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('x'); pylab.ylabel('y(x)')
    pylab.grid('on')
    pylab.show() 
