#!/usr/bin/env python
#
# Problem EPage 299
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

c = 5.
k = 120.
L = 0.2 
m = 1.0

def F(x,y): 
    # vector y is = [ x(t), x'(t) ] 
    F = zeros( (len(y),), dtype=float ) 
    F[0] = y[1] 
    F[1] = ( c/y[0]**2 - k * ( y[0] - L ) )/m
    return F 

x0 = 0.0 # start of the integration 
xStop = 1.0 # end of the integration 
h = 0.1
freq = 0

y0 = asarray( [ 1.e-16, 0 ], dtype=float ) 
X,Y = integrate(F,x0,y0,xStop,h) 
printSoln(X,Y,freq)

if True: 
    pylab.plot( X, Y[:,0] )
    pylab.xlabel('t'); pylab.ylabel('x(t)')
    pylab.grid('on')
    pylab.show() 
