#!/usr/bin/env python
#
# Problem EPage 280
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, zeros, sin, cos, pi 
from run_kut5 import integrate
from printSoln import printSoln
import pylab 

R_1 = 4
R_2 = 10
L = 0.032
C = 0.53
LC = L*C

def E(t): 
    if t < 0.005: 
        return 20.
    else: 
        return 0.

def F(t,y): 
    # the vector y is = [ q_1(t), q_2(t), i_1(t), i_2(t) ]
    q_1, q_2, i_1, i_2 = y
    F = zeros( (len(y),), dtype=float ) 
    F[0] = i_1 
    F[1] = i_2 
    F[2] = E(t)/L - (R_1/L) * i_1 - (R_2/L) * ( i_1 - i_2 )
    F[3] = -q_2/LC - (R_2/L)*( i_2 - i_1 )
    return F 

t0 = 0.0 # start of the integration 
tStop = 0.05 # end of the integration 
h = 1.e-2
freq = 0

y0 = asarray( [ 0., 0., 0., 0. ], dtype=float ) 
T,Y = integrate(F,t0,y0,tStop,h) 
printSoln(T,Y,freq)

if True: 
    pylab.plot( T, Y[:,2], label='i_1(t)' )
    pylab.hold('on')
    pylab.plot( T, Y[:,3], label='i_2(t)' )
    pylab.xlabel('t (time)')
    pylab.legend(loc='best')
    pylab.grid('on')
    pylab.axis('tight')
    pylab.show() 
