## module LRAlgorithm
''' lam,x = LRAlgorithm(a,tol=1.0e-6).
    The LR algorithm for finding the eigenvalues of [a]{x} = lam{x}. 
    It returns a sorted list of the eigenvalues of a
'''
from numpy import dot, diagonal
from numpy.linalg import cholesky, norm

def LRAlgorithm(a,tol=1.0e-9):
    ai = a.copy()
    for i in range(1,51):       # Begin iterations      
        L = cholesky(ai) 
        aip1 = dot(L.T,L)
        change_in_a = ai - aip1 
        error = norm( change_in_a.flatten() )
        if error < tol: return sorted( diagonal( aip1, offset=0 ) )
        ai = aip1.copy()
    print 'LR algorithm did not converge'


    
    
