#!/usr/bin/env python
#
# Problem EPage 362
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot, zeros, identity

from stdForm import stdForm
from jacobi import jacobi
from sortJacobi import sortJacobi

n = 10

A = zeros( (n,n) ) 

# Fill each element of the array A: 
# 
for ii in range(n):
    # Fill in the diagonal elements:
    # 
    if ii==0: 
        A[ii,ii] = 7
    elif ii==n-2:
        A[ii,ii] = 5
    elif ii==n-1:
        A[ii,ii] = 1
    else: 
        A[ii,ii] = 6

    # Fill in the off diagonal elements:
    # 
    for offset in range(1,2+1): 
        # Look left along each row: 
        column = ii-offset
        if column >= 0: 
            if offset==1: # first subdiagonal 
                if ii!=n-1: 
                    A[ii,column] = -4
                else: 
                    A[ii,column] = -2 
            if offset==2: # the second subdiagonal 
                A[ii,column] = 1

        # Look right along each row: 
        column = ii+offset
        if column < n:
            if offset==1: # the first superdiagonal
                if ii!=n-2: 
                    A[ii,column] = -4
                else: 
                    A[ii,column] = -2
            if offset==2: # the second superdiagoal 
                A[ii,column] = 1
#endfor 
A = A.astype(float) 

if False:
    print "A= "
    print A                 

# Create the B matrix: 
# 
B = identity( n ) 
B[n-1,n-1] = 0.5
B = B.astype(float) 

if False: 
    print "B= "
    print B 

# Convert our eigenvalue problem to standard form:
# 
H, T = stdForm(A.copy(),B.copy())
if True:
    print "H= "
    print H 
    print "T= "
    print T 

Lam, Z = jacobi(H.copy())
X = dot(T,Z) # eigenvalues of the original problem 
for jj in range(n): # normalize eigenvectors 
    xMag = sqrt(dot(X[:,jj],X[:,jj]))
    X[:,jj] /= xMag
sortJacobi(Lam,X) # arrange in ascending order
print "eigenvalues= ", Lam
print "eigenvectors= "
print X

if False:
    print "Checking Ax = lambda B x for our solution"
    print "A x= "
    AX = dot(A,X) 
    print AX
    print "lambda B x= "
    LBX = np.tile( Lam, (n,1) ) * dot(B,X)
    print LBX
    print "||A X - lambda B X||= ", np.linalg.norm( ( AX - LBX ).flatten() )
