#!/usr/bin/env python
#
# Problem EPage 364
#
# PYTHONPATH=../../BookCode:$PYTHONPATH
#
import numpy as np; from numpy import asarray, sqrt, diag, dot, zeros, identity, diagonal

from stdForm import stdForm
from jacobi import jacobi
from sortJacobi import sortJacobi
from inversePower import inversePower
from inversePower3 import inversePower3

n = 10

# Create the A matrix: 
# 
A = 2. * identity( n ) 
for ii in range(n):
    jj = ii-1
    if jj >= 0:
        A[ii,jj] = -1.
    jj = ii+1
    if jj <= n-1:
        A[ii,jj] = -1.
if False:
    print "A= "
    print A

# Create the B matrix: 
# 
B = identity( n ) 
B[4,4] = 1./1.5
for ii in range(5,9): 
    B[ii,ii] = 1./2
B[9,9] = 1./4
if False:
    print "B= "
    print B 

# Convert our eigenvalue problem to standard form:
# 
H, T = stdForm(A.copy(),B.copy())
if False:
    print "H= "
    print H 
    print "T= "
    print T 

Lam, Z = jacobi(H.copy())
X = dot(T,Z) # eigenvalues of the original problem 
for jj in range(n): # normalize eigenvectors 
    xMag = sqrt(dot(X[:,jj],X[:,jj]))
    X[:,jj] /= xMag
sortJacobi(Lam,X) # arrange in ascending order
print "jacobi eigenvalues[0]= ", Lam[0]
print "jacobi eigenvectors[:,0]= "
print X[:,0]

if False:
    print "Checking Ax = lambda B x for our solution"
    print "A x= "
    AX = dot(A,X) 
    print AX
    print "lambda B x= "
    LBX = np.tile( Lam, (n,1) ) * dot(B,X)
    print LBX
    print "||A X - lambda B X||= ", np.linalg.norm( ( AX - LBX ).flatten() )

# Use the inverse power method to compute the smallest eigenvalue (and corresponding eigenvector):
# 
lam, z = inversePower(H,s=0.0)
print "inversePower lambda= ", lam
x = dot(T,z)
x /= sqrt(dot(x,x))
print "inversePower eigenvector= ", x 

# Use the inverse power method (specified for tridiagonal matrices) to compute the smallest eigenvalue (and corresponding eigenvector):
# 
d = diagonal( H, offset=0 )
c = diagonal( H, offset=1 )
lam, z = inversePower3(d,c,s=0.0)
print "inversePower3 lambda= ", lam
x = dot(T,z)
x /= sqrt(dot(x,x))
print "inversePower3 eigenvector= ", x 

